#!/usr/bin/env python3

import secube, getpass, sys

def main():
    try:
        print (len(sys.argv))
        id = int(sys.argv[1])
        print(id)
        name = sys.argv[2]
        print(name)
        data = bytearray.fromhex(sys.argv[3])
        print(data)
        if len(sys.argv) > 4:
            validity=int(sys.argv[4])
            print(validity)
        else:
            validity=-365*24*3600
            print(validity)
    except:
        print("USAGE: add_key.py ID NAME DATA [VALIDITY]")
        return 1
    
    cube=secube.SEcube()
    password=getpass.getpass()
    cube.login(password)
    
    key=secube.SEcubeKey(name=name, id=id, data=data, validity=validity)
    cube.key_edit(secube.SE3_KEY_OP_UPSERT, key)
    cube.logout()
    cube.close()
    return 0
    
if __name__=="__main__":
    exit(main())