#!/usr/bin/env python3

import secube, getpass
import time
import sys

SE3_ALGO_AES = 0
SE3_ALGO_SHA256 = 1
SE3_ALGO_HMACSHA256 = 2
SE3_ALGO_AES_HMACSHA256 = 3
SE3_ALGO_MAX = 8

SE3_FEEDBACK_ECB = 1
SE3_FEEDBACK_CBC = 2
SE3_FEEDBACK_OFB = 3
SE3_FEEDBACK_CTR = 4
SE3_FEEDBACK_CFB = 5

SE3_DIR_SHIFT = 8
SE3_DIR_ENCRYPT = (1 << SE3_DIR_SHIFT)
SE3_DIR_DECRYPT = (2 << SE3_DIR_SHIFT)

SE3_CRYPTO_FLAG_FINIT = (1 << 15)
SE3_CRYPTO_FLAG_RESET = (1 << 14)
SE3_CRYPTO_FLAG_SETIV = SE3_CRYPTO_FLAG_RESET
SE3_CRYPTO_FLAG_SETNONCE = (1 << 13)
SE3_CRYPTO_FLAG_AUTH = (1 << 12)

def main():

    print("NOW %d"%int(time.time()))
    devs=secube.SEcube.discover()
    print("Found %d devices"%len(devs))
    for dev in devs:
        print(dev)

    if len(devs)>0:
        cube=secube.SEcube(devs[0])

        #password=getpass.getpass()
        password = "test"
        
        cube.login(pin=password, force=True)

        string2Cypher = sys.argv[1]
        print ()
        print ()
        print("[provaEncDec] String da cifrare -> " + string2Cypher)

        algorithm = SE3_ALGO_AES
        mode = SE3_FEEDBACK_ECB
        key_id = 1

        try:
            print ()
            print ()
            cube.crypto_set_time(int(time.time()))
            print("[provaEncDec - setTime] Time setted")

            stringCyphered = cube.encrypt(algorithm=algorithm, mode=mode, key_id=key_id, dataToChipher=string2Cypher)
            algoDigest = SE3_ALGO_HMACSHA256
            cube.digest(algorithm = algoDigest, key_id = key_id, data2Hash = stringCyphered)

            stringDecyphered = cube.decrypt(algorithm=algorithm, mode=mode, key_id=key_id, dataChiphered=stringCyphered)         

            stringDecyphered = "".join(map(chr, stringDecyphered))

            print()
            print()

            if(string2Cypher == stringDecyphered):
                print("[provaEncDec - check2Data] Matched")

            else:
                print("[provaEncDec - check2Data] No Match")

        finally:
            cube.logout()
            cube.close()
        
        return 0
    
if __name__=="__main__":
    exit(main())